(function () {
    "use strict";

    angular.module('core').controller('entradaDetailController', controller);
    controller.$inject = ['$scope', '$state', '$stateParams', '$q', '$alert', 'entradaService', 'lookupService', 'codigoBarraService','$element'];

    function controller($scope, $state, $stateParams, $q, $alert, entradaService, lookupService, codigoBarraService, $element) {

        $scope.initializeLayout('Entrada de Mercadorias');

        //[Inicializa objetos]
       
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            salvando: false,
            vazio: false,
            tabCorrente: 0,
            tabs: {
                detalhes: 0,
                mais: 1
            }
        };

        $scope.auxiliar = {
            fornecedor: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFornecedor({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            filial: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            produto: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllProduto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else {

                                    for (var index in response.Data) {
                                        response.Data[index].codigoProdutoOuBarras = response.Data[index].Codigo;
                                    }

                                    return response.Data;
                                }
                            })
                    );
                },
            },
            transportadora: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTransportadora({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            tabelaPreco: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTabelaPreco({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            condicaoPagamento: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllCondicaoPagamentoAtacado({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            grupoFiscalOperacao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllgrupoFiscalOperacao({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            naturezaOperacao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllnaturezaOperacao({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else {

                                    return response.Data;
                                }
                            })
                    );
                },
            },
            endereco: {
                prepare: function (index) {
                    contatoService
                        .prepareEndereco($scope.state.item.Enderecos[index])
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.state.item.Enderecos[index] = response.Data;
                                    $('[ng-model$="item.Linha2"]').focus();
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });
                },
                prepareNew: function () {
                    contatoService
                        .prepareNewEndereco($scope.state.item)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.state.item = response.Data;
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });

                },
            }
        };
        $scope.popups = {
            item: {
                ativo: false,
                vazio: false,
                carregando: false,
                filtro: { codigoProduto: null, entity: { codigoProdutoOuBarras: '' } },
                prepareNewItem: function () {
                     
                    if (!$scope.popups.item.filtro.entity.codigoProdutoOuBarras)
                        return;

                    $scope.popups.item.carregando = true;

                    var args = {
                        codigoProdutoOuBarras: $scope.popups.item.filtro.entity.codigoProdutoOuBarras,
                        entrada: $scope.state.item
                    };

                    entradaService
                        .prepareNewItem(args)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ text: response.Message, title: $scope.Title });
                                }
                                else {
                                    $scope.state.item = response.Data;
                                    $scope.popups.item.prepareFiltroProduto();
                                    $scope.popups.item.ativo = true;
                                }
                                $scope.popups.item.carregando = false;
                            },
                            function (_error) {
                                $scope.popups.item.carregando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                prepareFiltroProduto: function () {
                    /* Após preparar o item pelo código de barras, descobre o 
                     código do produto bipado para filtrar a edição do item
                     alimentando a propriedade codigoProduto. */
                    var args = { codigoBarra: $scope.popups.item.filtro.entity.codigoProdutoOuBarras };

                    codigoBarraService
                        .get(args)
                        .then(
                            function (response) {
                                if (response.Status >= 0) {

                                    if (response.Data)
                                        $scope.popups.item.filtro.entity.codigoProdutoOuBarras = response.Data.SKU.Produto.Codigo;

                                }
                            });
                },
                prepareItem: function () {
                    entradaService
                        .prepare({ item: $scope.state.item })
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.popups.item.ativo = false;
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.popups.item.ativo = false;
                                    $scope.state.item = response.Data;
                                    $scope.popups.item.filtro.codigoProdutoOuBarras = null;
                                }
                            },
                            function (_error) {
                                $scope.popups.addItem.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                }
            },
            fiscal: {
                ativo: false,
                toggle: function () {
                    $scope.popups.fiscal.ativo = !$scope.popups.fiscal.ativo;
                },
                steps: {
                    index: 0,
                    count: 3,
                    next: function () {
                        if ($scope.popups.fiscal.steps.customNext) {
                            $scope.popups.fiscal.steps.customNext();
                        }
                        else {
                            if ($scope.popups.fiscal.steps.index < ($scope.popups.fiscal.steps.count - 1))
                                $scope.popups.fiscal.steps.index++;
                        }
                    },
                    prior: function () {
                        if ($scope.popups.fiscal.steps.customPrior) {
                            $scope.popups.fiscal.steps.customPrior();
                        }
                        else {
                            if ($scope.popups.fiscal.steps.index > 0)
                                $scope.popups.fiscal.steps.index--;
                        }
                    }
                }
            }
        };

        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            entradaService
                .get($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.item = response.Data;

                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = !$scope.state.item;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };

        $scope.prepare = function () {
            entradaService
                .prepare($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            $scope.state.item = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    }
                );
        };
        $scope.fillChaveAcesso = function () {
            entradaService
                .fillChaveAcesso($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            $scope.state.item = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    }
                );
        };
        $scope.save = function () {
            $scope.state.salvando = true;
            entradaService
                .save($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0)
                            $alert({ title: $scope.Title, text: response.Message });
                        else {
                            $scope.state.item = response.Data;
                            $scope.historyBack();
                        }
                        $scope.state.salvando = false;
                    },
                    function (error) {
                        $scope.state.salvando = true;
                        $scope.tools.toastr.error(error, 'Não foi possível acessar o(s) servidor(es)');
                    }
                );
        };
        $scope.delete = function () {
            $scope.state.salvando = true;
            entradaService
                .delete({ id: $scope.state.item.ID })
                .then(
                    function (response) {
                        if (response.Status < 0)
                            $alert({ title: $scope.Title, text: response.Message });
                        else {
                            $scope.state.item = response.Data;
                            $scope.historyBack();
                        }
                        $scope.state.salvando = false;
                    },
                    function (error) {
                        $scope.state.salvando = true;
                        $scope.tools.toastr.error(error, 'Não foi possível acessar o(s) servidor(es)');
                    }
                );
        };
        $scope.refresh = function () {
            $scope.get();
        };

        $scope.cancel = function () {
            $scope.tools.toastr.info('Cancelando entrada...');
            entradaService
                .cancel({ id: $scope.state.item.ID })
                .then(
                    function (response) {
                        $scope.tools.toastr.clear();
                        if (response.Status < 0)
                            $alert({ text: response.Message, title: $scope.Title });
                        else {
                            $scope.tools.toastr.success("Entrada cancelada.");
                            $scope.state.item = response.Data;
                        }
                    },
                    function (error) {
                        $scope.tools.toastr.error(error, 'Não foi possível acessar o(s) servidor(es)');
                    }
                );
        };
        $scope.setConferida = function () {
            $scope.tools.toastr.info("Marcando entrada como conferida...");
            entradaService
                .setConferida({ id: $scope.state.item.ID })
                .then(
                    function (response) {
                        $scope.tools.toastr.clear();
                        if (response.Status < 0)
                            $alert({ text: response.Message, title: $scope.Title });
                        else {
                           
                            $scope.tools.toastr.success("Entrada marcada como conferida com êxito.");
                            $scope.initialize();
                        }
                    },
                    function (error) {
                        $alert({ text: error, title: $scope.Title });
                        $scope.tools.toastr.clear();
                        $scope.tools.toastr.error(error, 'Não foi possível acessar o(s) servidor(es)');
                    }
                );
        };

        $scope.efetivarFinanceiro = function () {
            $scope.tools.toastr.info('Efeivando movimentação de estoque...');
            $scope.state.salvado = true;
            entradaService
                .generateFinanceiro($scope.state.item)
                .then(
                    function (response) {
                        $scope.tools.toastr.clear();
                        if (response.Status < 0)
                            $alert({ text: response.Message, title: $scope.Title });
                        else {
                            $scope.tools.toastr.success("Financeiro gerado com  êxito", "Serviço");
                            $scope.state.item = response.Data;
                        }
                        $scope.state.salvado = true;
                    },
                    function (error) {
                        $scope.tools.toastr.error(error, 'Não foi possível acessar o(s) servidor(es)');
                    }
                );
        };

        $scope.generateRomaneio = function () {
            $scope.tools.toastr.info('Efeivando movimentação de estoque...');
            $scope.state.salvado = true;
            entradaService
                .generateRomaneio({ id: $scope.state.item.ID })
                .then(
                    function (response) {
                        $scope.tools.toastr.clear();
                        if (response.Status < 0)
                            $alert({ text: response.Message, title: $scope.Title });
                        else {
                            $scope.tools.toastr.success("Movimentação de estoque efetivada com êxito", "Serviço");
                            $scope.state.item = response.Data;
                        }
                        $scope.state.salvado = true;
                    },
                    function (error) {
                        $scope.tools.toastr.error(error, 'Não foi possível acessar o(s) servidor(es)');
                    }
                );
        };
        $scope.generateNotaFiscal = function () {
            $scope.tools.toastr.info('Gerando dados fiscais da entrada...');
            $scope.state.salvado = true;
            entradaService
                .generateNotaFiscal({ id: $scope.state.item.ID })
                .then(
                    function (response) {
                        $scope.tools.toastr.clear();
                        if (response.Status < 0)
                            $alert({ text: response.Message, title: $scope.Title });
                        else {
                            $scope.tools.toastr.success("Dados fiscais da entrada gerados com êxito", "Serviço");
                            $scope.state.item = response.Data;
                            $scope.popups.fiscal.toggle();
                        }
                        $scope.state.salvado = true;
                    },
                    function (error) {
                        $scope.tools.toastr.error(error, 'Não foi possível acessar o(s) servidor(es)');
                    }
                );
        };

        $scope.openupload = function () {
            document.getElementById('fileXml').click();
        };
        $scope.enviarxml = function (file) {
            if (angular.isUndefined(file))
                return;
            $scope.tools.toastr.info("Enviando arquivo...");
            entradaService
                .prepareXml($scope.state.item)
                .then(function () {
                    file.upload = Upload.upload({ url: '/entrada/ExportXml', data: { file: file } });

                    file.upload
                        .then(
                            function (response) {
                                $scope.tools.toastr.clear();
                                if (response.data.Status < 0)
                                    $alert({ text: response.data.Message, title: $scope.Title });
                                else {
                                    $scope.tools.toastr.success("Informação", "Nota Fiscal Gerada com Sucesso.");
                                }
                                $scope.state.financeiro.aba = null;
                            },
                            function (response) {
                                $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                            });

                });
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();

            /*fix submit não estava funcionando em conjuto com o componente de auto-complete */
            $(document).on('keypress', function (e) {
                if (e.which == 13 && $scope.popups.item.filtro.entity.codigoProdutoOuBarras) {
                    e.preventDefault();
                    $scope.popups.item.prepareNewItem();
                }
            });
        };

        $scope.initialize();

    }

})();